<?php
if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' );

/**
*
* @package  RealEstateManager
* @copyright 2009 Andrey Kvasnevskiy-OrdaSoft(akbet@mail.ru); Rob de Cleen(rob@decleen.com); Sergey Drughinin (Sergey.dru@gmail.com) ; 
* Homepage: http://www.joomlawebserver.com
* @version: 1.0.1 Pro $
*
**/

$mosConfig_absolute_path = $GLOBALS['mosConfig_absolute_path']	= JPATH_SITE;
require_once($mosConfig_absolute_path."/administrator/components/com_realestatemanager/compat.joomla1.5.php");

// load language
if (file_exists($mosConfig_absolute_path."/components/com_realestatemanager/language/{$mosConfig_lang}.php" ))
 {
  include_once($mosConfig_absolute_path."/components/com_realestatemanager/language/{$mosConfig_lang}.php" );
 } 
else 
 {
  include_once($mosConfig_absolute_path."/components/com_realestatemanager/language/english.php" );
 }

require_once($mosConfig_absolute_path."/components/com_realestatemanager/captcha.php");

/** load the html drawing class */
require_once( $mainframe->getPath( 'front_html' ) );
require_once( $mainframe->getPath( 'class' ) );
require_once ($mosConfig_absolute_path."/components/com_realestatemanager/realestatemanager.class.rent_request.php");
require_once ($mosConfig_absolute_path."/components/com_realestatemanager/realestatemanager.class.buying_request.php");
require_once ($mosConfig_absolute_path."/components/com_realestatemanager/realestatemanager.class.rent.php");
require_once ($mosConfig_absolute_path."/components/com_realestatemanager/realestatemanager.class.review.php");
require_once ($mosConfig_absolute_path."/administrator/components/com_realestatemanager/admin.realestatemanager.class.others.php");
require_once ($mosConfig_absolute_path."/administrator/components/com_realestatemanager/admin.realestatemanager.class.conf.php");


$GLOBALS['rentstatus_show'] = $realestatemanager_configuration['rentstatus']['show'];
$GLOBALS['rentrequest_registrationlevel'] = $realestatemanager_configuration['rentrequest']['registrationlevel'];
$GLOBALS['reviews_show'] = $realestatemanager_configuration['reviews']['show'];
$GLOBALS['reviews_registrationlevel'] = $realestatemanager_configuration['reviews']['registrationlevel'];
$GLOBALS['edocs_show'] = $realestatemanager_configuration['edocs']['show'];
$GLOBALS['edocs_registrationlevel'] = $realestatemanager_configuration['edocs']['registrationlevel'];
$GLOBALS['buy_now_show'] = $realestatemanager_configuration['buy_now']['show'];
$GLOBALS['buy_now_allow_categories'] = $realestatemanager_configuration['buy_now']['allow']['categories'];  
$GLOBALS['add_suggest_show'] = $realestatemanager_configuration['add_suggest']['show'];
$GLOBALS['add_suggest_registrationlevel'] = $realestatemanager_configuration['add_suggest']['registrationlevel'];

$GLOBALS['add_house_show'] = $realestatemanager_configuration['add_house']['show'];
$GLOBALS['add_house_registrationlevel'] = $realestatemanager_configuration['add_house']['registrationlevel'];

$GLOBALS['price_show'] = $realestatemanager_configuration['price']['show'];
$GLOBALS['price_registrationlevel'] = $realestatemanager_configuration['price']['registrationlevel'];
$GLOBALS['rentrequest_email_show'] = $realestatemanager_configuration['rentrequest_email']['show'];
$GLOBALS['rentrequest_email_address'] = $realestatemanager_configuration['rentrequest_email']['address'];
$GLOBALS['rentrequest_email_registrationlevel'] = $realestatemanager_configuration['rentrequest_email']['registrationlevel'];
$GLOBALS['buyingrequest_email_show'] = $realestatemanager_configuration['buyingrequest_email']['show'];
$GLOBALS['buyingrequest_email_address'] = $realestatemanager_configuration['buyingrequest_email']['address'];
$GLOBALS['buyingrequest_email_registrationlevel'] = $realestatemanager_configuration['buyingrequest_email']['registrationlevel'];

$GLOBALS['suggest_added_email_show'] = $realestatemanager_configuration['suggest_added_email']['show'];
$GLOBALS['suggest_email_address'] = $realestatemanager_configuration['suggest_email']['address'];
$GLOBALS['suggest_added_email_registrationlevel'] = $realestatemanager_configuration['suggest_added_email']['registrationlevel'];

$GLOBALS['license_show'] = $realestatemanager_configuration['license']['show'];
$GLOBALS['cat_pic_show'] = $realestatemanager_configuration['cat_pic']['show'];
$GLOBALS['debug'] = $realestatemanager_configuration['debug'];
$GLOBALS['edocs_location'] = $realestatemanager_configuration['edocs']['location'];
$GLOBALS['review_added_email_show'] = $realestatemanager_configuration['review_added_email']['show'];
$GLOBALS['review_email_address'] = $realestatemanager_configuration['review_email']['address'];
$GLOBALS['review_added_email_registrationlevel'] = $realestatemanager_configuration['review_added_email']['registrationlevel'];
$GLOBALS['license_show'] = $realestatemanager_configuration['license']['show'];
$GLOBALS['license_text'] = $realestatemanager_configuration['license']['text'];
$GLOBALS['subcategory_show'] = $realestatemanager_configuration['subcategory']['show'];
$GLOBALS['foto_high'] = $realestatemanager_configuration['foto']['high'];
$GLOBALS['foto_width'] = $realestatemanager_configuration['foto']['width'];

$GLOBALS['reviews_tab_show']=$realestatemanager_configuration['Reviews']['tab'];
$GLOBALS['reviewstab_registrationlevel'] = $realestatemanager_configuration['reviewstab']['registrationlevel'];	

$GLOBALS['location_show']=$realestatemanager_configuration['Location']['show'];					
$GLOBALS['locationtab_registrationlevel'] =$realestatemanager_configuration['location']['registrationlevel'];	

$GLOBALS['contacts_show']=$realestatemanager_configuration['Contacts']['show'];
$GLOBALS['contacts_registrationlevel'] = $realestatemanager_configuration['contacts']['registrationlevel'];	

$GLOBALS['realestatemanager_configuration'] = $realestatemanager_configuration;



$mainframe->setPageTitle( _REALESTATE_MANAGER_TITLE );

$task = trim( mosGetParam( $_REQUEST, 'task', "" ) );
$id = intval( mosGetParam( $_REQUEST, 'id', 0 ) );
$catid = intval(mosGetParam( $_REQUEST, 'catid', 0 ) );
$bids = mosGetParam($_REQUEST, 'bid', array(0));

// paginations
$intro    =  $realestatemanager_configuration['page']['items']; // page length

if ($intro) 
 {
  $paginations = 1;
  $limit    = intval( mosGetParam( $_REQUEST, 'limit', $intro ) );
  $GLOBALS['limit'] = $limit;
 
  $limitstart = intval( mosGetParam( $_REQUEST, 'limitstart', 0 ) );
  
  $GLOBALS['limitstart'] = $limitstart;

  $total    = 0;
  $LIMIT = 'LIMIT '.$limitstart.','.$limit;
 }
else 
{
  $paginations = 0;
  $LIMIT    = '';
}

 $session =& JFactory::getSession();
 $session->set("array",$paginations);
            

if($realestatemanager_configuration['debug'] == '1'){
  echo "Task: ".$task . "<br />";
  print_r($_POST);
  echo "<hr /><br />";
}


switch ($task)
{
        case 'secret_image':
        secretImage(); 
        break;

	case 'show_search':
	showSearchHouses( $option, $catid, $option );
	break;
	
	case 'search':
	searchHouses( $option, $catid, $option );
	break;

	case 'view':
	showItemREM( $id, $catid );
	break;

	case 'review':
	reviewHouse( $option );
	break;
	
	case 'showCategory':
	//if no category is selected show default action
	if ( $catid ) 
         {
	  showCategory( $catid );
	 } 
        else
         {
	  $task = "xxx";
	 }
	break;

	case 'rent_request':
		showRentRequest( $option, $bids );
	break;
	
	case 'save_rent_request':
		saveRentRequest( $option, $bids );
	break;

	case 'buying_request':
		saveBuyingRequest( $option, $bids );
	break;
	
	case 'mdownload':
		mydownload($id);
	break;

	case 'downitsf':
		downloaditself($id);	
	break;	
	
	case 'suggestion':  
		suggestion_func($option);
	break;

	case 'show_add' :
		editHouse($option, 0);
		break;

	case 'save_add' :		
		saveHouse($option);
		break;


	default:
		listCategories($catid);
	break;
	

}

function output_file($file, $name, $mime_type='')
{
 /*
 This function takes a path to a file to output ($file), 
 the filename that the browser will see ($name) and 
 the MIME type of the file ($mime_type, optional).
 
 If you want to do something on download abort/finish,
 register_shutdown_function('function_name');
 */
 if(!is_readable($file)) die('File not found or inaccessible!');
 
 $size = filesize($file);
 $name = rawurldecode($name);
 
 /* Figure out the MIME type (if not specified) */
 $known_mime_types=array(
  "pdf" => "application/pdf",
  "txt" => "text/plain",
  "html" => "text/html",
  "htm" => "text/html",
  "exe" => "application/octet-stream",
  "zip" => "application/zip",
  "doc" => "application/msword",
  "xls" => "application/vnd.ms-excel",
  "ppt" => "application/vnd.ms-powerpoint",
  "gif" => "image/gif",
  "png" => "image/png",
  "jpeg"=> "image/jpg",
  "jpg" =>  "image/jpg",
  "php" => "text/plain"
 );
 
 if($mime_type==''){
   $file_extension = strtolower(substr(strrchr($file,"."),1));
   if(array_key_exists($file_extension, $known_mime_types)){
    $mime_type=$known_mime_types[$file_extension];
   } else {
    $mime_type="application/force-download";
   };
 };
 
 //������ ������� � ����� �����
 $name = str_replace(" ","", $name);
 
 ob_end_clean(); //turn off output buffering to decrease cpu usage
 
 // required for IE, otherwise Content-Disposition may be ignored
 if(ini_get('zlib.output_compression'))
  ini_set('zlib.output_compression', 'Off');
 
// header('Content-Type: ' . $mime_type);
header('Content-Type: application/force-download');
// header('Content-Disposition: attachment; filename="'.$name.'"');
 header("Content-Disposition: inline; filename=$name");
 header("Content-Transfer-Encoding: binary");
 header('Accept-Ranges: bytes');
 
 /* The three lines below basically make the 
    download non-cacheable */
 header("Cache-control: private");
 header('Pragma: private');
 header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
 
 // multipart-download and download resuming support
 if(isset($_SERVER['HTTP_RANGE']))
 {
  list($a, $range) = explode("=",$_SERVER['HTTP_RANGE'],2);
  list($range) = explode(",",$range,2);
  list($range, $range_end) = explode("-", $range);
  $range=intval($range);
  if(!$range_end) {
    $range_end=$size-1;
  } else {
    $range_end=intval($range_end);
  }
 
  $new_length = $range_end-$range+1;
  header("HTTP/1.1 206 Partial Content");
  header("Content-Length: $new_length");
//  header("Content-Range: bytes $range-$range_end/$size");
 } else {
  $new_length=$size;
  header("Content-Length: ".$size);
 }


 $chunksize = 1*(1024*1024); //you may want to change this
 $bytes_send = 0;
 if ($file = fopen($file, 'r'))
 {
  if(isset($_SERVER['HTTP_RANGE']))
  fseek($file, $range);
 
  while(!feof($file) && 
    (!connection_aborted()) && 
    ($bytes_send<$new_length)
        )
  {
    $buffer = fread($file, $chunksize);
    print($buffer); //echo($buffer); // is also possible
    flush();
    $bytes_send += strlen($buffer);
  }
 fclose($file);
 } else die('Error - can not open file.');

die();

}



function mydownload($id)
{


 	global $realestatemanager_configuration;
	global $mosConfig_absolute_path;
        
        
	$session = & JFactory::getSession(); 
        $pas = $session->get("ssmid","default");
        $sid_1 = $session->getId();
       
 if(!($session->get("ssmid","default")) ||
		$pas == "" ||
	        $pas != $sid_1  ||
		$_COOKIE['ssd'] != $sid_1 ||
                
                !array_key_exists("HTTP_REFERER",$_SERVER )|| 
                $_SERVER["HTTP_REFERER"] == "" ||
                strpos($_SERVER["HTTP_REFERER"],$_SERVER['SERVER_NAME']) === false )    
	{
   	    echo '<H3 align="center">Link failure</H3>';
		exit;
	}
	
	if($GLOBALS['license_show'])
	{
		$fd = fopen($mosConfig_absolute_path."/components/com_realestatemanager/mylicense.php", "w" )
		or die ("Config license file is failure");
		fwrite( $fd, $GLOBALS['license_text']);
		fclose( $fd );
		HTML_realestatemanager :: displayLicense($id);
	}
	else{
		    downloaditself($id);
      }
}
function downloaditself($idt)
	{
	global $database,$my;
	global $realestatemanager_configuration;
	global $mosConfig_absolute_path;
		

 
	$session = & JFactory::getSession();
        $pas = $session->get("ssmid","default");
        $sid_1 = $session->getId();

	if(!($session->get("ssmid","default")) ||
		$pas == "" ||
	        $pas != $sid_1  ||
		$_COOKIE['ssd'] != $sid_1 ||
                
                !array_key_exists("HTTP_REFERER",$_SERVER )|| 
                $_SERVER["HTTP_REFERER"] == "" ||
                strpos($_SERVER["HTTP_REFERER"],$_SERVER['SERVER_NAME']) === false )    
	{
   	echo '<H3 align="center">Link failure</H3>';
		exit;
	}
	session_destroy();
        
	if(array_key_exists("id",$_POST )  )
		$id=intval($_POST['id']);
	else
		$id=$idt;

	$query = "SELECT * from #__rem_houses where id = ".$id;
	$database->setQuery( $query );
	$house = $database->loadObjectList();

	if(strpos($_SERVER["HTTP_REFERER"],$_SERVER['SERVER_NAME']) !== false )
		{
		 $name = explode('/',$house[0]->edok_link);



		 $file_path=$mosConfig_absolute_path.$GLOBALS['edocs_location'].$name[count($name)-1];


		 set_time_limit(0);	
		 output_file($file_path, $name[count($name)-1]);
		 exit;
	      }
	else
	      {
		header("Cache-control: private");
		header('Pragma: private');
		header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
		header("HTTP/1.1 301 Moved Permanently");
		header('Content-Type: application/force-download');
		header("Location: ".$house[0]->edok_link);
		 exit;
		}
	}

function saveRentRequest($option, $bids){
	global $mainframe, $database, $my, $Itemid, $acl;
	global $realestatemanager_configuration, $mosConfig_mailfrom;
	
//mosGetParam

  	if( !($GLOBALS['rentstatus_show'])  ||
    !checkAccess_REM($GLOBALS['rentrequest_registrationlevel'],'RECURSE', userGID_REM($my->id), $acl))
  {
                           
		echo _REALESTATE_MANAGER_NOT_AUTHORIZED;
		return;
  }
	
	$help = array();
//print_r($bids);exit;	
//print_r($_POST);exit;
	foreach($bids as $bid){
		$rent_request = new mosRealEstateManager_rent_request($database); 
       if (!$rent_request->bind($_POST)) {
			echo "<script> alert('".$rent_request->getError()."'); window.history.go(-1); </script>\n";
			exit ();
		}

		$rent_request->rent_request = date("Y-m-d H:i:s");
		$rent_request->fk_houseid = $bid;
			
//$rent_request->fk_houseid = 96; //???
//fk_houseid		
			//print_r($bid);exit;

	if($rent_request->rent_from >$rent_request->rent_until){
			echo "<script> alert('".
			$rent_request->rent_from.
			" is more than ".$rent_request->rent_until.
			"'); window.history.go(-1); </script>\n";
			exit ();
}
			$data  = &JFactory::getDBO();
			$query = "SELECT * FROM #__rem_houses where id= ".$bid;
			$data->setQuery($query);
			$houseid = $data->loadObjectList();
			$query   = "SELECT * FROM #__rem_rent where fk_houseid= ".
				   $houseid[0]->houseid." AND rent_return IS NULL" ;//изменить fk_houseid 
			$data->setQuery($query);
			$rents   = $data->loadObjectList();


//if($rent_request->rent_until<$rents[$e]->rent_from)
//{echo "<script> alert('".$rents[$e]->rent_from." > ".$rents[$e]->rent_until."'); window.history.go(-1); </script>\n";
		

//}
//print_r($rents);exit;

	if(isset($rents[0])){	
		for ($e = 0, $m = count($rents); $e < $m;$e++){
			$rents[$e]->rent_from= substr($rents[$e]->rent_from, 0, 10);
			$rents[$e]->rent_until= substr($rents[$e]->rent_until, 0, 10);
    
/*if(( $rent_from >=$rentTerm[$e]->rent_from && $rent_from<=$rentTerm[$e]->rent_until)||($rent_from<=$rentTerm[$e]->rent_from&&$rent_until>=$rentTerm[$e]->rent_until)||( $rent_until >=$rentTerm[$e]->rent_from && $rent_until<=$rentTerm[$e]->rent_until) )*/

//проверка аренды


if( ($rent_request->rent_from >= $rents[$e]->rent_from && $rent_request->rent_from <=$rents[$e]->rent_until)||($rent_request->rent_until >= $rents[$e]->rent_from && $rent_request->rent_until <=$rents[$e]->rent_until)||($rent_request->rent_from<=$rents[$e]->rent_from && $rent_request->rent_until>=$rents[$e]->rent_until) )
{
	echo "<script> alert('Sorry  this object already rent out from ".$rents[$e]->rent_from." to ".$rents[$e]->rent_until."'); window.history.go(-1); </script>\n";
			exit ();

 }


}


}

	
		if (!$rent_request->check()) {
			echo "<script> alert('".$rent_request->getError()."'); window.history.go(-1); </script>\n";
			exit ();
		}





		if (!$rent_request->store()) {
			echo "<script> alert('".$rent_request->getError()."'); window.history.go(-1); </script>\n";
			exit ();
		}

    $session =& JFactory::getSession();
    $password = $session->get('captcha_keystring', 'default');
		    
    $rent_request->checkin();
		array_push($help, $rent_request);
	}

	
	$currentcat = NULL;
	// Parameters
	$menu = new mosMenu( $database );
	$menu->load( $Itemid );
	$params = new mosParameters( $menu->params );
	$params->def( 'header', $menu->name );
	$params->def( 'pageclass_sfx', '' );
	//
	$params->def( 'show_search', '1' );
	$params->def( 'back_button', $mainframe->getCfg( 'back_button' ) );

	$currentcat->descrip = _REALESTATE_MANAGER_LABEL_RENT_REQUEST_THANKS;
	
	// page image
	$currentcat->img = "./components/com_realestatemanager/images/rem_logo.png";

	$currentcat->header = $params->get( 'header' );
	
	// used to show table rows in alternating colours
	$tabclass = array( 'sectiontableentry1', 'sectiontableentry2' );
	
//$houseid = mosGetParam($_POST, 'houseid');
//$i=$params->get('show_input_email');

			  // print_r($i);exit;
 
  if( ($GLOBALS['rentrequest_email_show']) &&
      trim($GLOBALS['rentrequest_email_address']) != "" )
    {
		  $params->def( 'show_email', 1 );
		  if (checkAccess_REM($GLOBALS['rentrequest_email_registrationlevel'],'RECURSE', userGID_REM($my->id), $acl)) {
			  $params->def( 'show_input_email', 1);
		}
	}

	if ($params->get('show_input_email')) {
    $mail_to = explode(",",$GLOBALS['rentrequest_email_address']);
     
    $userid = $my->id;
    //select user (added rent request)
    $zapros = "SELECT name, email FROM #__users WHERE id=".$userid.";";
    $database->setQuery($zapros);
    $item_user = $database->loadObjectList();
    echo $database->getErrorMsg();
			
	for ($i = 0;$i < count($bids);$i++){
			$zapros = "SELECT id, houseid, htitle FROM #__rem_houses WHERE id=".$bids[$i].";";
			//$zapros = "SELECT id, houseid, htitle FROM #__rem_houses WHERE id=4";
			$database->setQuery($zapros);
			$item_house = $database->loadObjectList();
			echo $database->getErrorMsg();
			$houseid = _REALESTATE_MANAGER_LABEL_HOUSEID;
			//print_r($bids);

      if ($userid == 0) {
			  mosMail( $mosConfig_mailfrom, 'anonymous',$mail_to, 
          'New rent request added!', 'User anonymous has submitted a Rent Request for:<br /><br /> '.
          $houseid.': '.$item_house[0]->houseid.'<br />'.
          $item_house[0]->htitle.'<br /><br /> '.
          'Please log on and approve or deny this Rent Request', true);
      } else {
        mosMail( $mosConfig_mailfrom, $item_user[0]->name,$mail_to,
          'New rent request added!', 
          'User '.$item_user[0]->name.' has submitted a Rent Request for:<br /><br /> '.
          $houseid.': '.$item_house[0]->houseid.'<br />'.          
          $item_house[0]->title.'<br /><br /> '.
          'Please log on and approve or deny this Rent Request', true);
      }
		}
	}
	//********************   end add send mail for admin   ****************

	HTML_realestatemanager :: showRentRequestThanks($params, $currentcat);
	
}

function saveBuyingRequest( $option, $bids ){
	global $mainframe, $database, $my, $Itemid, $acl;
	global $realestatemanager_configuration, $mosConfig_mailfrom;

	$buying_request = new mosRealEstateManager_buying_request($database);
	if (!$buying_request->bind($_POST)) {
			echo $buying_request->getError();
			exit ();
		}
	$buying_request->buying_request = date("Y-m-d H:i:s");
	$buying_request->fk_houseid = $bids[0];
	if (!$buying_request->store()) {
			echo "error:".$buying_request->getError();
// 			exit ();
		}
	$currentcat = NULL;
	// Parameters
	$menu = new mosMenu( $database );
	$menu->load( $Itemid );
	$params = new mosParameters( $menu->params );
	$params->def( 'header', $menu->name );
	$params->def( 'pageclass_sfx', '' );
	//
	$params->def( 'show_search', '1' );
	$params->def( 'back_button', $mainframe->getCfg( 'back_button' ) );

	$currentcat->descrip = _REALESTATE_MANAGER_LABEL_BUYING_REQUEST_THANKS;

	// page image
	$currentcat->img = "./components/com_realestatemanager/images/rem_logo.png";

	$currentcat->header = $params->get( 'header' );
    
	//sending notification
	if( ($GLOBALS['buyingrequest_email_show']) && trim($GLOBALS['buyingrequest_email_address']) != "" )
        {
		$params->def( 'show_email', 1 );
		if (checkAccess_REM($GLOBALS['buyingrequest_email_registrationlevel'],'RECURSE', userGID_REM($my->id), $acl)) {
			$params->def( 'show_input_email', 1);
		}
	}

	if ($params->get('show_input_email')) {
		$mail_to = explode(",",$GLOBALS['buyingrequest_email_address']);
		$userid = $my->id;
		//select user (added rent request)
		$zapros = "SELECT name, email FROM #__users WHERE id=".$userid.";";
		$database->setQuery($zapros);
		$item_user = $database->loadObjectList();
		echo $database->getErrorMsg();


		for ($i = 0;$i < count($bids);$i++){
			$zapros = "SELECT id, houseid, hlocation FROM #__rem_houses WHERE id=".$bids[$i].";";
			$database->setQuery($zapros);
			$item_house = $database->loadObjectList();
			echo $database->getErrorMsg();
			$houseid = _REALESTATE_MANAGER_LABEL_HOUSEID;
			
			if ($userid == 0) {
				mosMail( $mosConfig_mailfrom, 'anonymous',$mail_to,'New buying request added!', 'User anonymous  has submitted a Buying Request for:<br /><br /> '.$houseid.': '.$item_house[0]->houseid.'<br />'.     $item_house[0]->hlocation.'<br /><br /> '.          'Please log on and approve or deny this Buying Request', true);
			} else {
        mosMail( $mosConfig_mailfrom, $item_user[0]->name,$mail_to, 'New buying request added!','User '.$item_user[0]->name.' has submitted a Buying Request for:<br /><br /> '.$houseid.': '.$item_house[0]->houseid.'<br/>'.$item_house[0]->hlocation.'<br /><br /> '.'Please log on and approve or deny this Buying Request', true);
			}
		}
	}
	HTML_realestatemanager :: showRentRequestThanks($params, $currentcat);
}

function showRentRequest($option,$bid)
{	


	///sprint_r($bid);exit;
	
	global $mainframe, $database, $my, $Itemid, $acl;
	global $realestatemanager_configuration;

	
if( !($GLOBALS['rentstatus_show'])  ||
		!checkAccess_REM($GLOBALS['rentrequest_registrationlevel'],'RECURSE', userGID_REM($my->id), $acl))
                {
                  echo _REALESTATE_MANAGER_NOT_AUTHORIZED;
	  	  return;
        	}
	
		
	$bids = implode(',', $bid);
	
	// getting all houses for this category
	$query = "SELECT * FROM #__rem_houses"
		. "\nWHERE id IN (" .  $bids . ") ORDER BY catid, ordering";
	$database->setQuery( $query );
	$houses = $database->loadObjectList();
	
	//$houses
	$currentcat = NULL;
	// Parameters
	$menu = new mosMenu( $database );
	$menu->load( $Itemid );
	$params = new mosParameters( $menu->params );
	$params->def( 'header', _REALESTATE_MANAGER_DESC_TITLE );
	//$params->def( 'header', $menu->name );
	$params->def( 'pageclass_sfx', '' );
	$params->def( 'show_rentstatus', 1 );
	$params->def( 'show_rentrequest', 1 );
	$params->def( 'rent_save', 1); 
	$params->def( 'back_button', $mainframe->getCfg( 'back_button' ) );


	// page description
	$currentcat->descrip = _REALESTATE_MANAGER_DESC_RENT;
	
	// page image
	$currentcat->img = './components/com_realestatemanager/images/rem_logo.png';
	$currentcat->align = 'right';

	$currentcat->header = $params->get( 'header' );
	//$currentcat->header = $currentcat->header . ": " . $category->title;
	
	// used to show table rows in alternating colours
	$tabclass = array( 'sectiontableentry1', 'sectiontableentry2' );

	

//	HTML_realestatemanager :: showRentRequest($houses, $currentcat, $params, $tabclass, $catid, $sub_categories,is_exist_subcategory_houses($catid) );
	HTML_realestatemanager :: showRentRequest($houses, $currentcat, $params, $tabclass, $catid, $sub_categories,false);
}


/**
 * comments for registered users
 */
function reviewHouse()
{

	global $mainframe, $database, $my, $Itemid, $acl, $realestatemanager_configuration, $mosConfig_absolute_path, $catid;
	global $mosConfig_mailfrom,$session;
	

	if(!($GLOBALS['reviews_show'])  || !checkAccess_REM($GLOBALS['reviews_registrationlevel'],'RECURSE', userGID_REM($my->id), $acl)) 
        {
		echo _REALESTATE_MANAGER_NOT_AUTHORIZED;
	 	return;
	}	

	
        $review = new mosRealEstateManager_review($database);

	$review->date = date("Y-m-d H:i:s");
	$review->getReviewFrom( $my->id );

	
//*********************   begin compare to key   ***************************
	$session =& JFactory::getSession();
	$password = $session->get('captcha_keystring', 'default');

	if (array_key_exists('keyguest',$_POST) && ($_POST['keyguest'] !=  $password) 
		                                && (userGID_REM($my->id) <= 0) ) 
	{		
		mosRedirect("index.php?option=com_realestatemanager&task=view&catid=".$_POST["catid"]."&id=".
			$_POST["fk_houseid"]."&Itemid=$Itemid&title=".$_POST['title']."&comment=".
			$_POST['comment']."&rating=".$_POST['rating']."&err_msg=you typed bad characters from picture!");
		exit ();
	}
//**********************   end compare to key   *****************************

	if (!$review->bind($_POST)) {
		echo "<script> alert('".$house->getError()."'); window.history.go(-1); </script>\n";
		exit ();
	}
	
	if (!$review->check()) {
		echo "<script> alert('".$house->getError()."'); window.history.go(-1); </script>\n";
		exit ();
	}
	if (!$review->store()) {
		echo "<script> alert('".$house->getError()."'); window.history.go(-1); </script>\n";
		exit ();
	}

	//***************   begin add send mail for admin   ******************

	$menu =new mosMenu($database);
	$menu->load( $Itemid );
	$params = new mosParameters( $menu->params );

	if(($GLOBALS['review_added_email_show']) && trim($GLOBALS['review_email_address']) != "")
	{

	   $params->def('show_email', 1);
	   if (checkAccess_REM($GLOBALS['review_added_email_registrationlevel'],'RECURSE', userGID_REM($my->id), $acl)) {
			$params->def( 'show_input_email', 1);
	   }
	}


    if ($params->get('show_input_email')) 
    {
    $mail_to = explode(",",$GLOBALS['review_email_address']);

    //select house title
    $zapros = "SELECT title FROM #__rem_houses WHERE houseid = '".intval($_POST['fk_houseid'])."';";
    
    $database->setQuery($zapros);
    $house_title = $database->loadObjectList();
    echo $database->getErrorMsg();

		$t = _REALESTATE_MANAGER_LABEL_TITLE_REVIEW;//Review title
		$c = _REALESTATE_MANAGER_LABEL_TITLE_REVIEW_COMMENT;//Review comment
		$r = _REALESTATE_MANAGER_LABEL_RATING;//Rating
		$rating = (($item_review[0]->rating)/2);

    mosMail( $mosConfig_mailfrom, $review->user_name,$mail_to, 
      'New house review added','User '.$review->user_name.' has added a Review to house:<br />'.
      $house_title[0]->title. '<br /><br />'. 
      $t.': "'.$review->title.'"<br /><br />  '.
      $r.': ['.$rating.']<br /><br / '.
      $c.':<br /> '.$review->comment.'<br /><br /> '.
      'Please log on and edit this review where necessary.', true);
  }                   
	//********************   end add send mail for admin ************
	//showing the original entries
	mosRedirect("?option=com_realestatemanager&task=view&catid=".$_POST['catid']."&id=$review->fk_houseid&Itemid=$Itemid");

}

//*************   begin add for suggestion   ********************
function suggestion_func($option) 
{

	global $mainframe, $database, $my, $Itemid, $acl, $realestatemanager_configuration, $mosConfig_absolute_path, $catid;
	global $mosConfig_mailfrom,$session;

$session =& JFactory::getSession();
$password = $session->get('captcha_keystring', 'default');

//print_r($_REQUEST);

	if ($_REQUEST['where'] == 1) {
	   if ( array_key_exists('keyguest',$_REQUEST) 
        && ($_REQUEST['keyguest'] !=  $password) 
        && (userGID_REM($my->id) <= 0) ) {
		  mosRedirect("index.php?option=com_realestatemanager&Itemid=".
          $_REQUEST['Itemid']."&title=".$_REQUEST['title']."&comment=".
          $_REQUEST['comment']."&err_msg=you typed bad characters from picture!" );
		  exit ();
	   }
	}

	if ($_REQUEST['where'] == 2) {
	   session_start();
	   if ( array_key_exists('keyguest',$_REQUEST) 
        && ($_REQUEST['keyguest'] !=  $password) 
        && (userGID_REM($my->id) <= 0) ) 
     {
		//mosRedirect("?option=com_realestatemanager&task=view&catid=".$_POST['catid']."&id=$review->fk_houseid&Itemid=$Itemid");
			//suggestion_func(
		    mosRedirect("index.php?option=com_realestatemanager&task=showCategory&catid=".
          $_REQUEST['catid']."&Itemid=".$Itemid."&title=".$_REQUEST['title']."&err_msg=you typed bad characters from picture!");
		    exit ();
	   }
	}

	//insert data in database #__realestatemanager_suggestion
	$date = date("Y-m-d H:i:s");
	$title = $_REQUEST['title'];
	$comment = $_REQUEST['comment'];

  $user = new mosRealEstateManager_review( $database );
  $user->getReviewFrom($my->id);


  $stroka = "INSERT INTO #__rem_suggestion (user_name, user_email, date, title, comment)".
          "\n VALUES".
          "\n ('".$user->user_name ."','".$user->user_email ."' , '".$date."', '".$title."', '".$comment."');";
  $database->setQuery($stroka);
  $database->query();
  echo $database->getErrorMsg();

       // Parameters
    $menu =new mosMenu( $database );
    $menu->load( $Itemid );
    $params = new mosParameters( $menu->params );
    $params->def( 'header', $menu->name );
    $params->def( 'pageclass_sfx', '' );
    //
    $params->def( 'show_search', '1' );
    $params->def( 'back_button', $mainframe->getCfg( 'back_button' ) );

    $currentcat->descrip = _REALESTATE_MANAGER_LABEL_SUGGESTION_THANKS;

    // page image
    $currentcat->img = "./components/com_realestatemanager/images/rem_logo.png";

    $currentcat->header = $params->get( 'header' );

//*******   begin add send mail for admin   ******************
  	if(($GLOBALS['suggest_added_email_show']) && trim($GLOBALS['suggest_email_address']) != "" )
	{
		$params->def( 'show_email', 1 );

		if (checkAccess_REM($GLOBALS['suggest_added_email_registrationlevel'],'RECURSE', userGID_REM($my->id), $acl)) 
    {
			$params->def( 'show_input_email', 1);
		}
	}

	if ($params->get('show_input_email')) {
	    $mail_to = explode(",",$GLOBALS['suggest_email_address']);

		$t = _REALESTATE_MANAGER_LABEL_SUGGESTION_TITLE;
		$c = _REALESTATE_MANAGER_LABEL_SUGGESTION_COMMENT;

    mosMail($mosConfig_mailfrom, $user->user_name,$mail_to, 
      'New house suggestion added',
      'User '. $user->user_name .' has added a house suggestion <br /><br />' 
      .$t.': "'.$title.'" <br /> '
      .$c.': '.$comment. '<br /><br />'
      .' Please log in and check.', true);
	}

	//***********   end add send mail for admin**********
    HTML_realestatemanager :: showRentRequestThanks($params, $currentcat);
	//showing the original entries
//	if ($_REQUEST['where'] == 1) mosRedirect("?option=com_realestatemanager&Itemid=".$_REQUEST['Itemid']." ");
//	if ($_REQUEST['where'] == 2) mosRedirect("?option=com_realestatemanager&task=showCategory&catid=".$_REQUEST['catid']."&Itemid=".$_REQUEST['Itemid']." ");
}
//*******************   end add for suggestion   ********************


//this function check - is exist houses in this folder and folders under this category 
function is_exist_curr_and_subcategory_houses($catid) {
		global $database, $my; 

		$query = "SELECT *, COUNT(a.id) AS numlinks FROM #__categories AS cc" 
			. "\n LEFT JOIN #__rem_houses AS a ON a.catid = cc.id" 
			. "\n WHERE a.published='1' AND a.approved='1' AND section='com_realestatemanager' AND cc.id='$catid' AND cc.published='1' AND cc.access <= '$my->gid'" 
			. "\n GROUP BY cc.id" 
			. "\n ORDER BY cc.ordering"; 
		$database->setQuery( $query ); 
		$categories = $database->loadObjectList();
		if( count($categories) != 0 ) return true;

		$query = "SELECT id " 
			. "FROM #__categories AS cc " 
			. " WHERE section='com_realestatemanager' AND parent_id='$catid' AND published='1' AND access<='$my->gid'"; 
		$database->setQuery( $query ); 
		$categories = $database->loadObjectList();
 
		if( count($categories) == 0 ) return false;

		foreach($categories as $k) {
			if( is_exist_curr_and_subcategory_houses($k->id) ) return true;
		}
		return false; 
}//end function

//*****************************************************************************

//this function check - is exist folders under this category 
function is_exist_subcategory_houses($catid) {
		global $database, $my; 

		$query = "SELECT *, COUNT(a.id) AS numlinks FROM #__categories AS cc" 
			. "\n LEFT JOIN #__rem_houses AS a ON a.catid = cc.id" 
			. "\n WHERE a.published='1' AND a.approved='1' AND section='com_realestatemanager' AND parent_id='$catid' AND cc.published='1' AND cc.access <= '$my->gid'" 
			. "\n GROUP BY cc.id" 
			. "\n ORDER BY cc.ordering"; 
		$database->setQuery( $query ); 
		$categories = $database->loadObjectList();
		if( count($categories) != 0 ) return true;

		$query = "SELECT id " 
			. "FROM #__categories AS cc " 
			. " WHERE section='com_realestatemanager' AND parent_id='$catid' AND published='1' AND access<='$my->gid'"; 
		$database->setQuery( $query ); 
		$categories = $database->loadObjectList();
 
		if( count($categories) == 0 ) return false;

		foreach($categories as $k) {
			if( is_exist_subcategory_houses($k->id) ) return true;
		}
		return false; 
}//end function


/**
 * This function is used to show a list of all houses
 */
function listCategories( $catid ) 
{
//echo $catid ; exit;

	global $mainframe, $database, $my, $acl;
	global $mosConfig_shownoauth, $mosConfig_live_site, $mosConfig_absolute_path;
	global $cur_template, $Itemid, $realestatemanager_configuration;

	$query = "select c.id, c.parent_id, c.title, c.image, d.houses, '0' as display from (select id, parent_id, title, image from #__categories where section='com_realestatemanager' ORDER BY ordering ) as c left join ( select a.id as id, count(b.id) as houses  from #__categories as a, #__rem_houses as b  where b.catid=a.id and b.published=1 GROUP BY a.id) as d  on  c.id = d.id;";

	$database->setQuery( $query ); 
	$cat_all = $database->loadObjectList();

	for ($i = 0; $i < count($cat_all); $i++) {
		if (is_exist_curr_and_subcategory_houses($cat_all[$i]->id)) $cat_all[$i]->display = 1;
	}

	$currentcat = NULL;
	// Parameters
	$menu = new mosMenu( $database );
	$menu->load( $Itemid );
	$params = new mosParameters( $menu->params );
	$params->def( 'header', $menu->name );
	$params->def( 'pageclass_sfx', '' );
	$params->def( 'show_search', '1' );
	$params->def( 'back_button', $mainframe->getCfg( 'back_button' ) );

	// page header
	$currentcat->header = $params->get( 'header' );

//*****   begin add for Manager Suggestion: button 'Suggest a house'   
	if( ($GLOBALS['add_suggest_show']) ){
		$params->def( 'show_add_suggest', 1 );
		if (checkAccess_REM( $GLOBALS['add_suggest_registrationlevel'],'RECURSE', userGID_REM($my->id), $acl)) 
                {
			$params->def( 'show_input_add_suggest', 1);
		}
	}
//*********   end add for Manager Suggestion: button 'Suggest a house'   **

//*****   begin add for Manager Add house: button 'Add a house'   
	if( ($GLOBALS['add_house_show']) ){
		$params->def( 'show_add_house', 1 );
		if (checkAccess_REM( $GLOBALS['add_house_registrationlevel'],'RECURSE', userGID_REM($my->id), $acl)) 
                {
			$params->def( 'show_input_add_house', 1);
		}
	}
//*********   end add for Manager Add house: button 'Add a house'   **

	//add for show in category picture
	if(($GLOBALS['cat_pic_show'])) $params->def( 'show_cat_pic', 1 );

	// page description
	$currentcat->descrip = _REALESTATE_MANAGER_DESC;

	// used to show table rows in alternating colours
	$tabclass = array( 'sectiontableentry1', 'sectiontableentry2' );

	HTML_realestatemanager::showCategories($params, $cat_all, $catid, $tabclass, $currentcat);
}

function constructPathway($cat){
    global $mainframe, $database, $option, $Itemid,$mosConfig_absolute_path;

    $query = "SELECT * FROM #__categories WHERE section = 'com_realestatemanager' AND published = 1";
    $database->setQuery($query);
    $rows = $database->loadObjectlist('id');
    $pid = $cat->id;
    $pathway = array();
    $pathway_name = array();
    while($pid != 0){

      $cat = @$rows[$pid];

      $pathway[] =  sefRelToAbs('index.php?option=' . $option . '&task=showCategory&catid=' . @$cat->id . '&Itemid=' . $Itemid);
      $pathway_name[] =  @$cat->name  ;
      $pid = @$cat->parent_id;
    }

    $pathway = array_reverse($pathway);
    $pathway_name = array_reverse($pathway_name);

    for($i=0,$n=count($pathway);$i<$n;$i++){
      $mainframe->appendPathWay($pathway_name[$i],$pathway[$i] );
//echo $pathway[$i] ."::";
    }
//exit;
}

/**
 * This function is used to show a list of all houses
 */
function showCategory( $catid )
{

	global $mainframe, $database, $acl, $my;
	global $mosConfig_shownoauth, $mosConfig_live_site, $mosConfig_absolute_path;
	global $cur_template, $Itemid, $realestatemanager_configuration;




	// getting all houses for this category
	$query = "SELECT id, hits, hlocation, htitle, catid, fk_rentid, year, link, image_link , listing_type 	FROM #__rem_houses"
		. "\nWHERE catid = '$catid' AND published='1' AND approved='1'"
		. "\nORDER BY ordering";
	$database->setQuery( $query );
	$houses = $database->loadObjectList();	
	
	//getting the current category informations
	$query = "SELECT * FROM #__categories WHERE id='$catid'";
	$database->setQuery( $query );	
	$category = $database->loadObjectList();
	$category = $category[0];

	$query = "select c.id, c.parent_id, c.title, c.image, d.houses, '0' as display from (select id, parent_id, title, image from #__categories where section='com_realestatemanager' ) as c left join ( select a.id as id, count(b.id) as houses  from #__categories as a, #__rem_houses as b  where b.catid=a.id and b.published=1 GROUP BY a.id) as d  on  c.id = d.id;";

	$database->setQuery( $query ); 
	$cat_all = $database->loadObjectList();

	for ($i = 0; $i < count($cat_all); $i++) {
		if (is_exist_curr_and_subcategory_houses($cat_all[$i]->id)) $cat_all[$i]->display = 1;
	}
	

	$currentcat = NULL;
	// Parameters
	$menu = new mosMenu( $database );
	$menu->load( $Itemid );
	$params = new mosParameters( $menu->params );
	$params->def( 'header', $menu->name );
	$params->def( 'pageclass_sfx', '' );
	$params->def( 'category_name', $category->title );
	$params->def( 'show_search', '1' );
	

	constructPathway($category);
  $mainframe->appendPathWay($category->title);
  
	if( ($GLOBALS['rentstatus_show']) )
  {
		$params->def('show_rentstatus',1);
		if (checkAccess_REM($GLOBALS['rentrequest_registrationlevel'],'RECURSE', userGID_REM($my->id), $acl)) {
			$params->def( 'show_rentrequest', 1);
		}
	}

//*********   begin add for Manager Suggestion: button 'Suggest a house'   ****
	if( ($GLOBALS['add_suggest_show'])){
	
            	$params->def( 'show_add_suggest', 1 );

		if (checkAccess_REM($GLOBALS['add_suggest_registrationlevel'],'RECURSE', userGID_REM($my->id), $acl)) {

			$params->def( 'show_input_add_suggest', 1);
		}
	}
//*********   end add for Manager Suggestion: button 'Suggest a house'   ***

//*****   begin add for Manager Add house: button 'Add a house'   
	if( ($GLOBALS['add_house_show']) ){
		$params->def( 'show_add_house', 1 );
		
if (checkAccess_REM( $GLOBALS['add_house_registrationlevel'],'RECURSE', userGID_REM($my->id), $acl)) 
                {
			$params->def( 'show_input_add_house', 1);
		}
	}
//*********   end add for Manager Add house: button 'Add a house'   **

	//add for show in category picture
	if( ($GLOBALS['cat_pic_show']) ) $params->def( 'show_cat_pic', 1 );

	$params->def( 'show_rating', 1 );
	
	$params->def( 'hits', 1 );
	$params->def( 'back_button', $mainframe->getCfg( 'back_button' ) );

	$currentcat->descrip = $category->description;


	//print_r($category);exit;

//$pathway =  sefRelToAbs('index.php?option=' . $option . 
	//  		'&task=showCategory&catid=' . $category->id . '&Itemid=' . $Itemid);
    //$pathway_name =  $category->name  ;

	//$mainframe->appendPathWay($pathway_name,$pathway);
	//$mainframe->appendPathWay(" ");






	// page image
	$currentcat->img = null;
	$path = $mosConfig_live_site .'/images/stories/';
	if ( $category->image != null && count($category->image) > 0) {
		$currentcat->img = $path . $category->image;
		$currentcat->align = $category->image_position;
	}

	$currentcat->header = $params->get( 'header' );
	$currentcat->header = $currentcat->header . ": " . $category->title;

	// used to show table rows in alternating colours
	$tabclass = array( 'sectiontableentry1', 'sectiontableentry2' );

	HTML_realestatemanager::displayHouses($houses, $currentcat, $params, $tabclass, $catid, $cat_all,is_exist_subcategory_houses($catid) );
}



function showItemREM ($id, $catid) 
{
	global $mainframe, $database, $my, $acl, $option ;
	global $mosConfig_shownoauth, $mosConfig_live_site, $mosConfig_absolute_path;
	global $cur_template, $Itemid, $realestatemanager_configuration;
 
//print_r("ssssssss");exit;

	//add to path category name
	//getting the current category informations
	$query = "SELECT * FROM #__categories WHERE id='$catid'";
       
	$database->setQuery( $query );	
	$category = $database->loadObjectList();

	$category = $category[0];
  constructPathway($category);
  $pathway =  sefRelToAbs('index.php?option=' . $option . 
        '&task=showCategory&catid=' . $category->id . '&Itemid=' . $Itemid);
  $pathway_name =  "house"  ;

  $mainframe->appendPathWay($pathway_name,$pathway);
  $mainframe->appendPathWay(" ");


	//Record the hit
	$sql="UPDATE #__rem_houses SET hits = hits + 1 WHERE id = ". $id ."";
	$database->setQuery( $sql );
	$database->query();

	//load the house
	$house = new mosRealEstateManager( $database );
	$house->load($id);

//print_r($house);
 //echo '<br /><br />';

$session=&JFactory::getSession();
$session->get("obj_house",$house);
	
	// Parameters
	$menu = new mosMenu( $database );
	$menu->load( $Itemid );
	$params = new mosParameters( $menu->params );
	$params->def( 'header', $menu->name );
	$params->def( 'pageclass_sfx', '' );


	if( ($GLOBALS['rentstatus_show']) ){
		$params->def( 'show_rentstatus', 1 );
		if (checkAccess_REM($GLOBALS['rentrequest_registrationlevel'],'RECURSE', userGID_REM($my->id), $acl)) {
			$params->def( 'show_rentrequest', 1);
		}
	}
	
	if( ($GLOBALS['reviews_show']) ){
		$params->def( 'show_reviews', 1 );
		if (checkAccess_REM($GLOBALS['reviews_registrationlevel'],'RECURSE', userGID_REM($my->id), $acl)) {
			$params->def( 'show_inputreviews', 1);
		}
	}	
	
	if( ($GLOBALS['edocs_show']) ){
		$params->def( 'show_edocstatus', 1 );
		if (checkAccess_REM($GLOBALS['edocs_registrationlevel'],'RECURSE', userGID_REM($my->id), $acl)) {
			$params->def( 'show_edocsrequest', 1);//+18.01
				//+18.01
					}
		} 

	if( ($GLOBALS['price_show']) ){
		$params->def( 'show_pricestatus', 1 );
		if (checkAccess_REM($GLOBALS['price_registrationlevel'],'RECURSE', userGID_REM($my->id), $acl)) {
			$params->def( 'show_pricerequest', 1);//+18.01
		}
	}

//************   begin show 'location and reviews tab'   ***************************
if( ($GLOBALS['location_show']) ){
		$params->def( 'show_location', 1 );
		if (checkAccess_REM($GLOBALS['locationtab_registrationlevel'],'RECURSE', userGID_REM($my->id), $acl)) {
			$params->def( 'show_locationtab_registrationlevel', 1);//+18.01
		}
	}

if( ($GLOBALS['reviews_tab_show']) ){
		$params->def( 'show_reviews_tab', 1 );
		if (checkAccess_REM($GLOBALS['reviewstab_registrationlevel'],'RECURSE', userGID_REM($my->id), $acl)) {
			$params->def( 'show_reviewstab_registrationlevel', 1);//+18.01
		}
	}




//************   end show 'location and reviews tab'   ***************************
//************   begin show 'contacts'   ***************************

if( ($GLOBALS['contacts_show']) ){
		$params->def( 'show_contacts_line', 1 );

$y=checkAccess_REM($GLOBALS['reviewstab_registrationlevel'],'RECURSE', userGID_REM($my->id), $acl);

$i=checkAccess_REM($GLOBALS['contacts_registrationlevel'],'RECURSE', userGID_REM($my->id), $acl);

if($i){



		$params->def('show_contacts_registrationlevel', 1);//+18.01
				}

	

	}

//************   begin add button 'buy now'   ***************************

	
   if(($GLOBALS['buy_now_show']) ){
		$params->def( 'show_buy_now', 1 );
		$s = explode(',',$GLOBALS['buy_now_allow_categories']);
    foreach($s as $i )
    {
			if($i == $catid || $i == -2) {
        $params->def( 'show_input_buy_now', 1);
        break;
      }
		}
	}

//************   end add button 'buy now'   ********************************

	
	$params->def( 'pageclass_sfx', '' );
	$params->def( 'item_description', 1 );
	$params->def( 'rent_request', $GLOBALS['rentrequest_registrationlevel']);
	$params->def( 'show_edoc', $GLOBALS['edocs_show']);
	$params->def( 'show_price', $GLOBALS['price_show']);
	$params->def( 'back_button', $mainframe->getCfg( 'back_button' ) );
	
	// page header
	$currentcat->header = $params->get( 'header' );
	$currentcat->header = $currentcat->header . ": " . $house->htitle;
	
	$query = "select main_img from #__rem_photos WHERE fk_houseid=$house->id";
	$database->setQuery( $query );
	$house_photos = $database->loadObjectList();
	// show the house
	HTML_realestatemanager::displayHouse( $house, $tabclass, $params, $currentcat, $ratinglist, $house_photos );
}


/**
* Compiles a list of records
* @param database - A database connector object
* select categories
*/
function showHouses($option)
{
  global $database, $mainframe, $mosConfig_list_limit;

	$limit = $mainframe->getUserStateFromRequest("viewlistlimit", 'limit', $mosConfig_list_limit);
	$limitstart = $mainframe->getUserStateFromRequest("view{$option}limitstart", 'limitstart', 0);
	$catid = $mainframe->getUserStateFromRequest("catid{$option}", 'catid', '-1');//old 0
	$rent = $mainframe->getUserStateFromRequest("rent{$option}", 'rent', '-1');//add nik
	$pub = $mainframe->getUserStateFromRequest("pub{$option}", 'pub', '-1');//add nik

	$search = $mainframe->getUserStateFromRequest("search{$option}", 'search', '');
	$search = $database->getEscaped(trim(strtolower($search)));

	$where = array ();

	if ($rent == "rent") {
		array_push($where, "a.fk_rentid <> 0");
	} else if ($rent == "not_rent") {
		array_push($where, "a.fk_rentid = 0");
	} 
	if ($pub== "pub") {
		array_push($where, "a.published = 1");
	} else if ($pub == "not_pub") {
		array_push($where, "a.published = 0");
	}
	if ($catid > 0) {
		array_push($where, "a.catid='$catid'");
	}
	

	if ($search) {
		array_push($where, "(LOWER(a.htitle) LIKE '%$search%' OR LOWER(a.hlocation) LIKE '%$search%' OR LOWER(a.houseid) LIKE '%$search%')");
	}


	$database->setQuery("SELECT count(*) FROM #__rem_houses AS a".
						"\nLEFT JOIN #__rem_rent AS l".
						"\nON a.fk_rentid = l.id". 
						(count($where) ? "\nWHERE ".implode(' AND ', $where) : ""));

	$total = $database->loadResult();
	echo $database->getErrorMsg();

	require_once ($GLOBALS['mosConfig_absolute_path'].'/administrator/includes/pageNavigation.php');
	$pageNav = new mosPageNav($total, $limitstart, $limit);

	$selectstring = "SELECT a.*, cc.title AS category, l.id as rentid, l.rent_from as rent_from, l.rent_return as rent_return, l.rent_until as rent_until, u.name AS editor".
					"\nFROM #__rem_houses AS a".
					"\nLEFT JOIN #__categories AS cc ON cc.id = a.catid".
					"\nLEFT JOIN #__rem_rent AS l ON a.fk_rentid = l.id".
					"\nLEFT JOIN #__users AS u ON u.id = a.checked_out".
					(count($where) ? "\nWHERE ".implode(' AND ', $where) : "").
					"\nORDER BY a.catid, a.ordering".
					"\nLIMIT $pageNav->limitstart,$pageNav->limit;";
	$database->setQuery($selectstring);
	$rows = $database->loadObjectList();

	//echo $rows[0];exit;	

	if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}

	// get list of categories
	/*
	 * select list treeSelectList
	 */

	$categories[] = mosHTML :: makeOption('0', _REALESTATE_MANAGER_LABEL_SELECT_CATEGORIES);
	$categories[] = mosHTML :: makeOption('-1', _REALESTATE_MANAGER_LABEL_SELECT_ALL_CATEGORIES);
	//$database->setQuery("SELECT id AS value, title AS text FROM #__categories"."\nWHERE section='com_realestatemanager' ORDER BY ordering");
//	$categories = array_merge($categories, $database->loadObjectList());//old valid
//	$clist = mosHTML :: selectList($categories, 'catid', 'class="inputbox" size="1" onchange="document.adminForm.submit();"', 'value', 'text', $catid);//old valid

//*************   begin add for sub category in select in manager houses   *************
	$options = $categories;
	$id = 0;//$categories_array;
        $list = CAT_Utils::categoryArray();

        $cat = new mosCategory($database);
        $cat->load($id);

        $this_treename = '';
        foreach ($list as $item) {
            if ($this_treename) {
                if ($item->id != $cat->id && strpos($item->treename, $this_treename) === false) {
                    $options[] = mosHTML::makeOption($item->id, $item->treename);
                }
            } else {
                if ($item->id != $cat->id) {
                    $options[] = mosHTML::makeOption($item->id, $item->treename);
                } else {
                    $this_treename = "$item->treename/";
                }
            }
        }

	$clist = mosHTML::selectList($options, 'catid', 'class="inputbox" size="1" onchange="document.adminForm.submit();"', 'value', 'text', $catid);//new nik edit

//	$clist = mosHTML :: selectList($categories, 'catid', 'class="inputbox" size="1" onchange="document.adminForm.submit();"', 'value', 'text', $catid);//old valid
//*****  end add for sub category in select in manager houses   **********

	$rentmenu[] = mosHTML :: makeOption('0', _REALESTATE_MANAGER_LABEL_SELECT_TO_RENT);
	$rentmenu[] = mosHTML :: makeOption('-1', _REALESTATE_MANAGER_LABEL_SELECT_ALL_RENT);
	$rentmenu[] = mosHTML :: makeOption('not_rent', _REALESTATE_MANAGER_LABEL_SELECT_NOT_RENT);
	$rentmenu[] = mosHTML :: makeOption('rent', _REALESTATE_MANAGER_LABEL_SELECT_RENT);

	$rentlist = mosHTML :: selectList($rentmenu, 'rent', 'class="inputbox" size="1" onchange="document.adminForm.submit();"', 'value', 'text', $rent);

	$pubmenu[] = mosHTML :: makeOption('0', _REALESTATE_MANAGER_LABEL_SELECT_TO_PUBLIC);
	$pubmenu[] = mosHTML :: makeOption('-1', _REALESTATE_MANAGER_LABEL_SELECT_ALL_PUBLIC);
	$pubmenu[] = mosHTML :: makeOption('not_pub', _REALESTATE_MANAGER_LABEL_SELECT_NOT_PUBLIC);
	$pubmenu[] = mosHTML :: makeOption('pub', _REALESTATE_MANAGER_LABEL_SELECT_PUBLIC);

	$publist = mosHTML :: selectList($pubmenu, 'pub', 'class="inputbox" size="1" onchange="document.adminForm.submit();"', 'value', 'text', $pub);


	HTML_realestatemanager :: showHouses($option, $rows, $clist, $rentlist, $publist, $search, $pageNav);
}


/**
* Compiles information to add or edit houses
* @param integer bid The unique id of the record to edit (0 if new)
* @param array option the current options
*/
function editHouse($option,$bid) 
{
	global $database, $my, $mosConfig_live_site, $realestatemanager_configuration;

	$house = new mosRealEstateManager($database);
	
	// load the row from the db table
	$house->load(intval($bid));
	$numeric_houseids = Array();
	
	if(empty($house->houseid) &&
     		$realestatemanager_configuration['houseid']['auto-increment']['boolean'] == 1 ) 
  {
		$database->setQuery("select houseid from #__rem_houses order by houseid");
		$houseids = $database->loadObjectList();

		foreach($houseids as $houseid){
	if( !is_numeric($houseid->houseid) ){    
			echo "<script> alert('You have no numeric houseId. Please set option".  		  				     _REALESTATE_MANAGER_ADMIN_CONFIG_HOUSEID_AUTO_INCREMENT.
                	     " to \'No\' or change all houseID to numeric '); window.history.go(-1); </script>\n";
			exit ();
			}
			$numeric_houseids[] =  intval($houseid->houseid);
		}
		
	if(count($numeric_houseids) > 0) {
			sort($numeric_houseids);
			$house->houseid = $numeric_houseids[ count($numeric_houseids)-1 ] + 1 ;
		}
       else $house->houseid = 1;
    
  }

  	$house->year = "1900";
  	$house->expiration_date = "2027-12-31";
	
  // get list of categories
	$categories[] = mosHTML :: makeOption('0', _REALESTATE_MANAGER_LABEL_SELECT_CATEGORIES);

	$database->setQuery("SELECT id AS value, name AS text FROM #__categories".
    " WHERE section='$option' ORDER BY ordering");
	$categories = array_merge($categories, $database->loadObjectList());

	if (count($categories) <= 1) {
		mosRedirect("index2.php?option=com_realestatemanager&section=categories",
       _REALESTATE_MANAGER_ADMIN_IMPEXP_ADD);
	}

	$clist = mosHTML :: selectList($categories, 'catid', 'class="inputbox" size="1"', 'value', 'text', intval($house->catid));


	//get Rating
	$retVal2 = mosRealEstateManagerOthers :: getRatingArray();
	$rating = null;
	for ($i = 0, $n = count($retVal2); $i < $n; $i ++) {
		$help = & $retVal2[$i];
		$rating[] = mosHTML :: makeOption($help[0], $help[1]);
	}

	/*$ratinglist = mosHTML :: selectList($rating, 'rating', 'class="inputbox" size="1"', 'value', 'text', $house->rating);*/

	//delete ehouse?
	$help = str_replace($mosConfig_live_site, "", $house->edok_link);
	$delete_ehouse_yesno[] = mosHTML :: makeOption($help, _REALESTATE_MANAGER_YES);
	$delete_ehouse_yesno[] = mosHTML :: makeOption('0', _REALESTATE_MANAGER_NO);
	$delete_edoc = mosHTML :: RadioList($delete_ehouse_yesno, 'delete_edoc',
     'class="inputbox"', '0', 'value', 'text');

	// fail if checked out not by 'me'
	if ($house->checked_out && $house->checked_out <> $my->id) {
		mosRedirect("index2.php?option=$option", _REALESTATE_MANAGER_IS_EDITED);
	}

	if ($bid) {
		$house->checkout($my->id);
	} else {
		// initialise new record
		$house->published = 0;
		$house->approved = 0;
	}

//print_r($house);exit;


	//cоздание списка "тип сделки"
	$listing_type[] = mosHtml::makeOption('foreclosure',_REALESTATE_MANAGER_OPTION_FORECLOSURE);
	$listing_type[] = mosHtml::makeOption('house for rent',_REALESTATE_MANAGER_OPTION_HOUSE_FOR_RENT);
	$listing_type[] = mosHtml::makeOption('room for rent',_REALESTATE_MANAGER_OPTION_ROOM_FOR_RENT);
	$listing_type[] = mosHtml::makeOption('for sale',_REALESTATE_MANAGER_OPTION_FOR_SALE);
	$listing_type[] = mosHtml::makeOption('new home',_REALESTATE_MANAGER_OPTION_NEW_HOME);
	$listing_type[] = mosHtml::makeOption('sublet',_REALESTATE_MANAGER_OPTION_SUBLET);
	$listing_type_list = mosHTML :: selectList($listing_type, 'listing_type', 'class="inputbox" size="1"', 'value', 'text', $house->listing_type);

	//cоздание списка "тип цены"
	$test[] = mosHtml::makeOption('negotiable',_REALESTATE_MANAGER_OPTION_NEGOTIABLE);
	$test[] = mosHtml::makeOption('starting',_REALESTATE_MANAGER_OPTION_STARTING);
	$test_list = mosHTML :: selectList($test, 'price_type', 'class="inputbox" size="1"', 'value', 'text', $house->price_type);

	//cоздание списка "статус сделки"
	$listing_status_type[] = mosHtml::makeOption('active',_REALESTATE_MANAGER_OPTION_ACTIVE);
	$listing_status_type[] = mosHtml::makeOption('offer',_REALESTATE_MANAGER_OPTION_OFFER);
	$listing_status_type[] = mosHtml::makeOption('contract',_REALESTATE_MANAGER_OPTION_CONTRACT);
	$listing_status_type[] = mosHtml::makeOption('closed',_REALESTATE_MANAGER_OPTION_CLOSED);
	$listing_status_type[] = mosHtml::makeOption('withdrawn',_REALESTATE_MANAGER_OPTION_WITHDRAWN);
	$listing_status_list = mosHTML :: selectList($listing_status_type, 'listing_status', 'class="inputbox" size="1"', 'value', 'text', $house->listing_status);

	

	$property_type[] = mosHtml::makeOption('apartment',_REALESTATE_MANAGER_OPTION_APARTMENT);
	$property_type[] = mosHtml::makeOption('commercial',_REALESTATE_MANAGER_OPTION_COMMERCIAL);
	$property_type[] = mosHtml::makeOption('condo',_REALESTATE_MANAGER_OPTION_CONDO);
	$property_type[] = mosHtml::makeOption('coop',_REALESTATE_MANAGER_OPTION_COOP);
	$property_type[] = mosHtml::makeOption('farm',_REALESTATE_MANAGER_OPTION_FARM);
	$property_type[] = mosHtml::makeOption('land',_REALESTATE_MANAGER_OPTION_LAND);
	$property_type[] = mosHtml::makeOption('manufactured',_REALESTATE_MANAGER_OPTION_MANUFACTURED);
	$property_type[] = mosHtml::makeOption('multifamily',_REALESTATE_MANAGER_OPTION_MULTIFAMILY);
	$property_type[] = mosHtml::makeOption('ranch',_REALESTATE_MANAGER_OPTION_RANCH);
	$property_type[] = mosHtml::makeOption('single family',_REALESTATE_MANAGER_OPTION_SINGLE_FAMILY);
	$property_type[] = mosHtml::makeOption('tic',_REALESTATE_MANAGER_OPTION_TIC);
	$property_type[] = mosHtml::makeOption('townhouse',_REALESTATE_MANAGER_OPTION_TOWNHOUSE);
	$property_type_list = mosHTML :: selectList($property_type, 'property_type', 'class="inputbox" size="1"', 'value', 'text', $house->property_type);
	
	//cоздание списка "класс провайдера"
	$provider_class[] = mosHtml::makeOption('agent',_REALESTATE_MANAGER_OPTION_AGENT);
	$provider_class[] = mosHtml::makeOption('aggregator',_REALESTATE_MANAGER_OPTION_AGGREGATOR);
	$provider_class[] = mosHtml::makeOption('broker',_REALESTATE_MANAGER_OPTION_BROKER);
	$provider_class[] = mosHtml::makeOption('franchisor',_REALESTATE_MANAGER_OPTION_FRANCHISOR);
	$provider_class[] = mosHtml::makeOption('homebuilder',_REALESTATE_MANAGER_OPTION_HOMEBUILDER);
	$provider_class[] = mosHtml::makeOption('publisher',_REALESTATE_MANAGER_OPTION_PUBLISHER);
//	$provider_class[] = mosHtml::makeOption('mls',"mls");
	$provider_class_list = mosHTML :: selectList($provider_class, 'provider_class', 'class="inputbox" size="1"', 'value', 'text', $house->provider_class);

	//cоздание списка "районирование"
	$zoning[] = mosHtml::makeOption('agricultural',_REALESTATE_MANAGER_OPTION_AGRICULTURAL);
	$zoning[] = mosHtml::makeOption('commercial',_REALESTATE_MANAGER_OPTION_COMMERCIAL);
	$zoning[] = mosHtml::makeOption('industrial',_REALESTATE_MANAGER_OPTION_INDUSTRIAL);
	$zoning[] = mosHtml::makeOption('recreational',_REALESTATE_MANAGER_OPTION_RECREATIONAL);
	$zoning[] = mosHtml::makeOption('residential',_REALESTATE_MANAGER_OPTION_RESIDENTIAL);
	$zoning[] = mosHtml::makeOption('unincorporated',_REALESTATE_MANAGER_OPTION_UNINCORPORATED);
	$zoning_list = mosHTML :: selectList($zoning, 'zoning', 'class="inputbox" size="1"', 'value', 'text', $house->zoning);

	//cоздание списка "style"
	$style[] = mosHtml::makeOption('Cape Cod',_REALESTATE_MANAGER_OPTION_CAPE_COD);
	$style[] = mosHtml::makeOption('Colonial',_REALESTATE_MANAGER_OPTION_COLONIAL);
	$style[] = mosHtml::makeOption('Craftsman',_REALESTATE_MANAGER_OPTION_CRAFTSMAN);
	$style[] = mosHtml::makeOption('Gothic',_REALESTATE_MANAGER_OPTION_GOTHIC);
	$style[] = mosHtml::makeOption('Prairie',_REALESTATE_MANAGER_OPTION_PRAIRIE);
	$style[] = mosHtml::makeOption('Ranch',_REALESTATE_MANAGER_OPTION_RANCH2);
	$style[] = mosHtml::makeOption('Split Level',_REALESTATE_MANAGER_OPTION_SPLIT_LEVEL);
	$style[] = mosHtml::makeOption('Tudor',_REALESTATE_MANAGER_OPTION_TUDOR);
	$style[] = mosHtml::makeOption('Victorian Queen Anne',_REALESTATE_MANAGER_OPTION_VICTORIAN_QUEEN_ANNE);
	$style_list = mosHTML :: selectList($style, 'style', 'class="inputbox" size="1"', 'value', 'text', $house->style);
	
	$query = "select main_img from #__rem_photos WHERE fk_houseid=$house->id";
	$database->setQuery( $query );
	$house_photos = $database->loadObjectList();


	HTML_realestatemanager :: editHouse($option, $house, $clist, $ratinglist, $delete_edoc, $test_list, $listing_status_list, $property_type_list, $listing_type_list, $provider_class_list, $zoning_list, $style_list, $house_photos);
//print_r($test1);exit;
}

function guid(){
    if (function_exists('com_create_guid')){
        return com_create_guid();
    }else{
        mt_srand((double)microtime()*10000);//optional for php 4.2.0 and up.
        $charid = strtoupper(md5(uniqid(rand(), true)));
        $hyphen = chr(45);// "-"
        $uuid = //chr(123)// "{"
                substr($charid, 0, 8).$hyphen
                .substr($charid, 8, 4).$hyphen
                .substr($charid,12, 4).$hyphen
                .substr($charid,16, 4).$hyphen
                .substr($charid,20,12);
                //.chr(125);// "}"
        return $uuid;
    }
}

/**
* Saves the record on an edit form submit
* @param database A database connector object
*/
function picture_thumbnail($file){
  global $mosConfig_absolute_path;
  
  //разделение имени файла на имя и расширение
  $file_name = substr($file, 0, strlen($file)-4);
  $file_type = substr($file, strlen($file)-4);
  $file_type = strtolower($file_type);
  // Setting the resize parameters
  list($width, $height) = getimagesize($mosConfig_absolute_path.'/components/com_realestatemanager/photos/'.$file);
  // Creating the Canvas
  $tn= imagecreatetruecolor(70, 70);
  
  //проверка типа
  switch ( strtolower($file_type) ) {
      case '.png':
        //  echo 'type of your image is PNG';
	  $source = imagecreatefrompng($mosConfig_absolute_path.'/components/com_realestatemanager/photos/'.$file);
	  $file = imagecopyresized($tn, $source, 0, 0, 0, 0, 70, 70, $width, $height);
	  imagepng($tn,$mosConfig_absolute_path.'/components/com_realestatemanager/photos/'.$file_name."_mini".$file_type);
	  break;
      case '.jpg':
        //  echo 'type of your image is JPG';
	  $source = imagecreatefromjpeg($mosConfig_absolute_path.'/components/com_realestatemanager/photos/'.$file);
	  $file = imagecopyresized($tn, $source, 0, 0, 0, 0, 70, 70, $width, $height);
	  imagejpeg($tn,$mosConfig_absolute_path.'/components/com_realestatemanager/photos/'.$file_name."_mini".$file_type);
	  break;
      case '.gif':
        //  echo 'type of your image is GIF';
	  $source = imagecreatefromgif($mosConfig_absolute_path.'/components/com_realestatemanager/photos/'.$file);
	  $file = imagecopyresized($tn, $source, 0, 0, 0, 0, 70, 70, $width, $height);
	  imagegif($tn,$mosConfig_absolute_path.'/components/com_realestatemanager/photos/'.$file_name."_mini".$file_type);
	  break;
      default:
	  echo 'not support';
	  return;
  }
  return $file_name."_mini".$file_type;
}
function saveHouse($option) 
{	
	//global $mainframe, $database, $my,  $acl, $realestatemanager_configuration, $mosConfig_absolute_path, 
	global $database, $my,$mosConfig_absolute_path, $mosConfig_live_site, $realestatemanager_configuration,$catid,$Itemid,$mainframe,$params;

	//check how the other info should be provided
	$house = new mosRealEstateManager($database);	

   if (!$house->bind($_POST)) {
    	 echo "<script> alert('".$house->getError()."'); window.history.go(-1); </script>\n";
    	 exit ();
  }


   if(isset($_POST['contacts'])){
    $house->contacts = mosGetParam( $_REQUEST, 'contacts', '' ); 
 
  }

	//сохранение основного изображения 
	$uploaddir = $mosConfig_absolute_path.'/components/com_realestatemanager/photos/';
	$code=guid();
   if($_FILES['image_link']['name']!= '') {
	$uploadfile = $uploaddir.$code."_".basename($_FILES['image_link']['name']);
	$file_name = $code."_".$_FILES['image_link']['name'];
 
  if(copy($_FILES['image_link']['tmp_name'], $uploadfile))
	{
	    $mini_file_name = picture_thumbnail($file_name);
	    $house->image_link = $file_name; 
      $idd = mosGetParam( $_REQUEST, 'houseid', 0 );
 
	    $database->setQuery("UPDATE #__rem_houses SET image_link='$file_name' WHERE houseid=$idd");
				
			if (!$database->query()) {
  			echo "<script> alert('".$database->getErrorMsg()."');</script>\n";
			}
	}
   } //end if


      if($_POST['edok_link'] != '') $house->edok_link =  mosGetParam( $_REQUEST, 'edok_link', '' ); 
                //delete ehouse file if neccesary
  		/*$delete_edoc = mosGetParam($_POST, 'delete_edoc', 0);
  	
	if($delete_edoc != '0'){
      		$retVal = @unlink($mosConfig_absolute_path . $delete_edoc);
    	        $house->edok_link = "";
  } */


	//storing e-house
	$edfile = $_FILES['edoc_file'];
	//check if fileupload is correct
	if($realestatemanager_configuration['edocs']['allow'] 
	      && intval($edfile['error']) > 0 
	      && intval($edfile['error']) < 4){

		echo "<script> alert('" . _REALESTATE_MANAGER_LABEL_EDOCUMENT_UPLOAD_ERROR . 
      "'); window.history.go(-1); </script>\n";
		exit ();

	}else if ($realestatemanager_configuration['edocs']['allow'] 
	      && intval($edfile['error']) != 4){	
	        $uploaddir = $mosConfig_absolute_path .
	        $realestatemanager_configuration['edocs']['location'];
	  	$file_new = $uploaddir.basename($_FILES['edoc_file']['name']);

	  if(!copy($edfile['tmp_name'],  $file_new)){
	    echo "<script> alert('error: not copy'); window.history.go(-1); </script>\n";
	    exit ();
    }
		else {
	        $house->edok_link = $mosConfig_live_site .
                $realestatemanager_configuration['edocs']['location'] . $edfile['name'];
		}
	}

	if (is_string($house)) {
		echo "<script> alert('".$house."'); window.history.go(-1); </script>\n";
		exit ();
	}

		$house->date = date("Y-m-d H:i:s");


	if(get_magic_quotes_gpc()) {
	        $house->description = stripslashes($house->description);  
        }

	if (!$house->store()) {
		echo "<script> alert('".$house->getError()."'); window.history.go(-1); </script>\n";
		exit ();
	}

	//$house->checkin();
	//$house->updateOrder( "catid='$house->catid'" );
	//$house->updateOrder("catid='$row->catid'");
	//$id = $row->id;

	//сохранение динамических файлов в папку photos
		$uploaddir = $mosConfig_absolute_path.'/components/com_realestatemanager/photos/';
	if(array_key_exists("new_photo_file", $_FILES)) {
	 for ($i = 0; $i < count($_FILES['new_photo_file']['name'] ); $i++){
		$code=guid();

	  	$uploadfile = $uploaddir.$code."_".basename($_FILES['new_photo_file']['name'][$i]);

	
	if(copy($_FILES['new_photo_file']['tmp_name'][$i], $uploadfile)){
		$file_name = $code."_".$_FILES['new_photo_file']['name'][$i];
		$mini_file_name = picture_thumbnail($file_name);
//сохранение имен файлов в таблицу БД
		$database->setQuery("INSERT INTO #__rem_photos VALUES ( '','$house->id','$mini_file_name','$file_name')");
	if (!$database->query()){
		//echo "<script> alert('".$database->getErrorMsg()."');</script>\n";
		//$mini_file_name = picture_thumbnail($file_name);
			  }
		  }
   	}//for
  }  //end if
	

      // Parameters
    $menu = new mosMenu( $database );
    $menu->load( $Itemid );
    $params = new mosParameters( $menu->params );
    $params->def( 'header', $menu->name );
    $params->def( 'pageclass_sfx', '' );
    //
    $params->def( 'show_search', '1' );
    $params->def( 'back_button', $mainframe->getCfg( 'back_button' ) );

    $currentcat->descrip = _REALESTATE_MANAGER_LABEL_REAL_ESTATE_THANKS;

    // page image
    $currentcat->img = "./components/com_realestatemanager/images/rem_logo.png";

    $currentcat->header = $params->get( 'header' );

 HTML_realestatemanager :: showRentRequestThanks($params, $currentcat);
}





function showSearchHouses($options, $catid, $option)
{

	global $mainframe, $database, $my;
	global $mosConfig_shownoauth, $mosConfig_live_site, $mosConfig_absolute_path;
	global $cur_template, $Itemid;
	
	$currentcat = NULL;
	// Parameters
	$menu = new mosMenu( $database );
	$menu->load( $Itemid );
	$params = new mosParameters( $menu->params );
	$params->def( 'header', $menu->name );
	$params->def( 'pageclass_sfx', '' );
	//
	$params->def( 'show_search', '1' );
	$params->def( 'back_button', $mainframe->getCfg( 'back_button' ) );

	$currentcat->descrip = " ";
      	$currentcat->align = 'right';
	
	// page image
	$currentcat->img = "./components/com_realestatemanager/images/rem_logo.png";


	$currentcat->header = $params->get( 'header' );
	$currentcat->header = $currentcat->header . ": " . _REALESTATE_MANAGER_LABEL_SEARCH;
	
	// used to show table rows in alternating colours
	$tabclass = array( 'sectiontableentry1', 'sectiontableentry2' );

	$categories[] = mosHTML :: makeOption('0', 'Search category');
	$database->setQuery("SELECT id AS value, name AS text FROM #__categories"."\nWHERE section='$option' ORDER BY ordering");
	$categories = array_merge($categories, $database->loadObjectList());

	if (count($categories) < 1) {
	    mosRedirect("index2.php?option=categories&amp;section=$option&amp;err_msg=You must first create category for that section.");
	}

	$clist = mosHTML :: selectList($categories, 'catid', 'class="inputbox" size="1"', 'value', 'text', 0);


	// show the House
	HTML_realestatemanager::showSearchHouses( $params, $currentcat, $clist , $option);

}

function searchHouses($options, $catid, $option){

	global $mainframe, $database, $my, $acl;
	global $mosConfig_shownoauth, $mosConfig_live_site, $mosConfig_absolute_path;
	global $cur_template, $Itemid, $realestatemanager_configuration;
	
        $session = &JFactory::getSession();

  if(array_key_exists("searchtext",$_REQUEST)){	
  	$search = mosGetParam( $_REQUEST, 'searchtext', '' );
        $session->set("poisk",$search);	
  }	
        
  $poisk_search = $session->get("poisk","default");        

	$where 	        = array();
	$Address            = " ";
	$Title              = " ";
	$Broker             = " ";
	$Feature            = " ";
	$Description        = " ";
	$Listing_type       = " ";
	$Property_ownership = " ";
	$Model 	            = " ";
	$Style       	    = " ";
	$Agent 	            = " ";
	$Zoning             = " ";
	$Rent               = " ";
	$RentSQL            = " ";
	$RentSQL_JOIN_1	    = " ";
	$RentSQL_JOIN_2     = " ";
	$RentSQL_rent_until = " ";
  
  
  $is_add_or = false;
  $add_or_value  = "  ";
	if(isset($_POST['Address']) && $_POST['Address']=="on"){
      $Address = " ";
      if($is_add_or) $Address = " or " ;
      $is_add_or = true;
      $Address .=" LOWER(b.hlocation) LIKE '%$poisk_search%' ";       
	}
	if(isset($_POST['Title']) && $_POST['Title']=="on"){
      $Title = " ";
      if($is_add_or) $Title = " or " ;
      $is_add_or = true;
      $Title .=" LOWER(b.htitle) LIKE '%$poisk_search%' ";       
	}

	if(isset($_POST['Broker']) && $_POST['Broker']=="on"){
      $Broker = " ";
      if($is_add_or) $Broker = " or " ;
      $is_add_or = true;
      $Broker .=" LOWER(b.broker) LIKE '%$poisk_search%' ";       
	}

	if(isset($_POST['Feature']) && $_POST['Feature']="on"){
      $Feature = " ";
      if($is_add_or) $Feature = " or " ;
      $is_add_or = true;
      $Feature .=" LOWER(b.feature) LIKE '%$poisk_search%' ";       
	}

	if(isset($_POST['Listing_type']) && $_POST['Listing_type']=="on"){	
      $Listing_type = " ";
      if($is_add_or) $Listing_type = " or " ;
      $is_add_or = true;
      $Listing_type .=" LOWER(b.listing_type) LIKE '%$poisk_search%' ";       
	}
	
	if(isset($_POST['description']) && $_POST['description']=="on"){	
      $Description = " ";
      if($is_add_or) $Description = " or " ;
      $is_add_or = true;
      $Description .=" LOWER(b.description) LIKE '%$poisk_search%' ";       
	}
	
	if(isset($_POST['Property_ownership']) && $_POST['Property_ownership']=="on"){	
      $Property_ownership = " ";
      if($is_add_or) $Property_ownership = " or " ;
      $is_add_or = true;
      $Property_ownership .=" LOWER(b.property_type) LIKE '%$poisk_search%' ";       
	}
	
	if(isset($_POST['Model']) && $_POST['Model']=="on"){	
      $Model = " ";
      if($is_add_or) $Model = " or " ;
      $is_add_or = true;
      $Model .=" LOWER(b.model) LIKE '%$poisk_search%' ";       
	}

	if(isset($_POST['Style']) && $_POST['Style']=="on"){	
      $Style = " ";
      if($is_add_or) $Style = " or " ;
      $is_add_or = true;
      $Style .=" LOWER(b.style) LIKE '%$poisk_search%' ";       
	}

	if(isset($_POST['Agent']) && $_POST['Agent']=="on"){	
      $Agent = " ";
      if($is_add_or) $Agent = " or " ;
      $is_add_or = true;
      $Agent .=" LOWER(b.agent) LIKE '%$poisk_search%' ";       
	}

	if(isset($_POST['Zoning']) && $_POST['Zoning']=="on"){	
      $Zoning = " ";
      if($is_add_or) $Zoning = " or " ;
      $is_add_or = true;
      $Zoning .=" LOWER(b.zoning) LIKE '%$poisk_search%' ";       
  }


    //  print_r($_REQUEST['search_date_from']);exit;
    $search_date_from = $_REQUEST['search_date_from'];
    if( ! get_magic_quotes_gpc()  )  $search_date_from = addslashes($search_date_from) ;
    $search_date_until = $_REQUEST['search_date_until'];
    if( ! get_magic_quotes_gpc()  )  $search_date_until = addslashes($search_date_until) ;
  
  if(isset($_REQUEST['search_date_from']) && ( trim($_REQUEST['search_date_from'])  ) && trim($_REQUEST['search_date_until']) == "" ){ 
      $RentSQL="  ( ( fk_rentid = 0 OR
       NOT EXISTS (select dd.fk_houseid from #__rem_rent AS dd where dd.rent_until > '".
       $search_date_from."' and dd.rent_from < '".
       $search_date_from."' and dd.fk_houseid=b.id ) ) ".
      " AND (listing_type = \"house for rent\" OR 
      listing_type = \"room for rent\" OR 
      listing_type = \"sublet\" ) ) ";
      if($is_add_or) $RentSQL .= " AND " ;
 
      $RentSQL_JOIN_1="\nLEFT JOIN #__rem_rent AS d "; 
      $RentSQL_JOIN_2="\nON d.fk_houseid=b.id ";
  }
  if(isset($_REQUEST['search_date_until']) && (trim($_REQUEST['search_date_until']) ) && trim($_REQUEST['search_date_from']) == "" ){ 
      $RentSQL="  ( ( fk_rentid = 0  OR
       NOT EXISTS (select dd.fk_houseid from #__rem_rent AS dd where dd.rent_from < '".
       $search_date_until."' and dd.rent_until > '".
       $search_date_until."' and dd.fk_houseid=b.id ) ) ".
      " AND (listing_type = \"house for rent\" OR 
      listing_type = \"room for rent\" OR 
      listing_type = \"sublet\" ) ) ";
      if($is_add_or) $RentSQL .= " AND " ;
 
      $RentSQL_JOIN_1="\nLEFT JOIN #__rem_rent AS d "; 
      $RentSQL_JOIN_2="\nON d.fk_houseid=b.id ";
  }
  if(isset($_REQUEST['search_date_until']) && (trim($_REQUEST['search_date_until']) ) 
    && isset($_REQUEST['search_date_from']) && ( trim($_REQUEST['search_date_from'])  ) ){ 
      $RentSQL="  ( ( fk_rentid = 0 OR
       NOT EXISTS (select dd.fk_houseid from #__rem_rent AS dd where  ( dd.rent_until > '".
       $search_date_from."' and dd.rent_from < '".
       $search_date_from."' )   or ".
      " ( dd.rent_from < '".$search_date_until .
      "' and dd.rent_until > '".$search_date_until."' ) or ".
      " ( dd.rent_from > '".
      $search_date_from."' and dd.rent_until < '".
      $search_date_until."' ) ) ) ".
      " AND (listing_type = \"house for rent\" OR 
      listing_type = \"room for rent\" OR 
      listing_type = \"sublet\" ) ) ";
      if($is_add_or) $RentSQL .= " AND " ;
 
      $RentSQL_JOIN_1="\nLEFT JOIN #__rem_rent AS d "; 
      $RentSQL_JOIN_2="\nON d.fk_houseid=b.id ";
  }
  
  $RentSQL = $RentSQL.(($is_add_or)?( "( ( ".$Address."  " . $Title."  ". $Broker . "  ".
      $Feature."  ". $Listing_type." ". $Description." ". $Property_ownership."  ". $Model ."  ". $Style . " " .
       $Agent."  ".  $Zoning  ."  ))"):(" "));
  if( trim($RentSQL) !="" ) array_push($where, $RentSQL );
  
  array_push($where, " b.published = '1' " );
  array_push($where, " b.approved = '1' " );
  
  if($catid){
		array_push($where, "c.id=$catid");
	}
	
	// getting all houses for this category
    $query = "SELECT distinct  b . * , c.title AS category_titel, c.ordering AS category_ordering
      FROM #__rem_houses AS b
      LEFT JOIN #__categories AS c ON b.catid = c.id ".
      $RentSQL_JOIN_1.$RentSQL_JOIN_2. 
      ((count($where) ? "\n WHERE ".implode(' AND ', $where) : "")).
      " ORDER BY category_ordering, ordering LIMIT 0 , 30 ";
	//print_r($query);exit;
	$database->setQuery( $query );
	$houses = $database->loadObjectList();  
  
  
	if(!isset($houses[0]->id)){ 
		unset($houses[0]);}

	$currentcat = NULL;
	// Parameters
	$menu = new mosMenu( $database );
	$menu->load( $Itemid );
	$params = new mosParameters( $menu->params );
	$params->def( 'header', $menu->name );
	$params->def( 'pageclass_sfx', '' );
	$params->def( 'category_name', _REALESTATE_MANAGER_LABEL_SEARCH );
	$params->def( 'search_request', '1' );	
	$params->def( 'hits', 1 );
	$params->def( 'show_rating', 1 );
	
	if(($GLOBALS['rentstatus_show'])){
		$params->def( 'show_rentstatus', 1 );
		if (checkAccess_REM( $GLOBALS['rentrequest_registrationlevel'],'RECURSE', userGID_REM($my->id), $acl)) {
			$params->def( 'show_rentrequest', 1);
		}
	}

//*******   begin add for Manager Suggestion: button 'Suggest a house' *******
	if(($GLOBALS['add_suggest_show'])){
		$params->def( 'show_add_suggest', 1 );
		if (checkAccess_REM($GLOBALS['add_suggest_registrationlevel'],'RECURSE', userGID_REM($my->id), $acl)) {
			$params->def( 'show_input_add_suggest', 1);
		}
	}
//****   end add for Manager Suggestion: button 'Suggest a house'   *****


//*****   begin add for Manager Add house: button 'Add a house'   
	if( ($GLOBALS['add_house_show']) ){
		$params->def( 'show_add_house', 1 );
		if (checkAccess_REM( $GLOBALS['add_house_registrationlevel'],'RECURSE', userGID_REM($my->id), $acl)) 
                {
			$params->def( 'show_input_add_house', 1);
		}
	}
//*********   end add for Manager Add house: button 'Add a house'   **

	//add for show in category picture
	if(($GLOBALS['cat_pic_show'])) $params->def('show_cat_pic',1);

	$params->def( 'back_button', $mainframe->getCfg('back_button'));

	$currentcat->descrip = " ";
	$currentcat->align = 'right';
	// page image
	$currentcat->img = "./components/com_realestatemanager/images/rem_logo.png";

  $currentcat->header = $params->get( 'header' );
	$currentcat->header = $currentcat->header .":". _REALESTATE_MANAGER_LABEL_SEARCH;
	
	// used to show table rows in alternating colours
	$tabclass = array( 'sectiontableentry1', 'sectiontableentry2' );
	
	
	if(isset($houses[0])){	
		HTML_realestatemanager::displayHouses($houses, $currentcat, $params, $tabclass, $catid, null,false);
	}else{
	print_r("<h1 >&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"._REALESTATE_MANAGER_LABEL_SEARCH_NOTHING_FOUND." </h1><br><br> ");
	   }
	}

function secretImage()
{ 
      $session =& JFactory::getSession();
      $pas = $session->get('captcha_keystring', 'default');

	 $new_img = new PWImage();
	 $new_img->set_show_string($pas);
	 $new_img->get_show_image(2.2, array(mt_rand(0,50), mt_rand(0,50), mt_rand(0,50)), array(mt_rand(200,255),
     mt_rand(200,255), mt_rand(200,255)));
         exit();

}

function checkAccess_REM( $accessgroupid, $recurse, $usersgroupid, $acl) {
	
	//parse usergroups
	$tempArr = array();
	$tempArr = explode(',',$accessgroupid);
//	print_r($tempArr);echo ':<BR />'; print_r($usersgroupid);
//	echo ':<BR />';
	for($i = 0;$i<count($tempArr);$i++)
	{
	 if($tempArr[$i] == $usersgroupid || $tempArr[$i]==-2){
		return 1;
		}else 
		if($recurse == 'RECURSE'){
			$groupchildren=array();
			$groupchildren=$acl->get_group_children( $tempArr[$i], 'ARO', $recurse );
			if(is_array($groupchildren)&& count($groupchildren) > 0) 
				if ( in_array($usersgroupid, $groupchildren) )
					return 1;
					}
		
	}
        
		//deny access
     		return 0;
	  
}

function userGID_REM($oID){
  	global $database,$ueConfig;
	if($oID > 0) {
		$query = "SELECT gid FROM #__users WHERE id = '".$oID."'";
		$database->setQuery($query);
		$gid = $database->loadResult();
		return $gid;
	}
	else return 0;
}

?>
